<template>
  <div>
    <GI18nCard
      :i18n="i18n"
      :title="title"
      :level="level"
      :card="card"
      :border="border"
      v-bind="$attrs"
      :wiki-entry="wikiEntry"
    >
      <template #card-title>
        <slot name="card-title" />
      </template>
      <template #card-title-append>
        <v-spacer />
        <GIconBtn
          i18n="form.moveDown"
          icon="keyboard_arrow_down"
          :color="iconColor"
          small-btn
          @click="$emit('move-down')"
        />
        <GIconBtn
          i18n="form.moveUp"
          icon="keyboard_arrow_up"
          :color="iconColor"
          small-btn
          @click="$emit('move-up')"
        />
        <GIconBtn
          v-if="maximized"
          i18n="form.minimize"
          icon="remove"
          :color="iconColor"
          small-btn
          @click="minimize"
        />
        <GIconBtn
          v-else
          i18n="form.maximize"
          icon="check_box_outline_blank"
          :color="iconColor"
          small-btn
          @click="maximize"
        />
        <span class="mx-4">|</span>
        <slot name="card-title-append" />
        <GIconBtn
          i18n="form.delete"
          icon="delete"
          :color="iconColor"
          small-btn
          @click="$emit('remove')"
        />
      </template>
      <v-expand-transition class="border-primary">
        <div v-show="maximized">
          <slot />
        </div>
      </v-expand-transition>
    </GI18nCard>
  </div>
</template>

<script>
import GI18nCard from "./GI18nCard";
import GIconBtn from "~/components/App/Common/GIconBtn.vue";
export default {
  name: "GCollapsibleCard",
  components: { GIconBtn, GI18nCard },
  props: {
    card: {
      type: Boolean,
      default: true,
    },
    i18n: String,
    title: String,
    level: String,
    border: {
      type: Boolean,
      default: false,
    },
    wikiEntry: String,
  },
  data() {
    return {
      maximized: true,
    };
  },
  computed: {
    iconColor() {
      return "white";
    },
  },
  methods: {
    maximize() {
      this.maximized = true;
      this.$emit("maximize");
    },
    minimize() {
      this.maximized = false;
      this.$emit("minimize");
    },
  },
};
</script>

<style>
.border-primary {
  border: 1px solid lightgrey;
}
</style>
